;;
.include "tn2313def.inc"								;  - ATTiny2313;
										; -  ;
.equ vol_addr= 0b00000000;;
;;
.equ l_addr = 0b11000000;;
.equ r_addr = 0b11100000;;
;;
.equ treb_addr = 0b01110000;;
.equ bass_addr = 0b01100000;;
.equ audio_addr= 0b01000000;;
;;
;=================					;  I2C
.equ	SCLP	= 5										; SCL  ( D);
.equ	SDAP	= 4										; SDA  ( D);
.equ	b_dir	= 0										
.equ	i2crd	= 1;;
.equ	i2cwr	= 0;;
;  I2C
.def	i2cdelay= r22									;  ;
.def	i2cdata	= r23									;  
.def	i2cadr	= r24									;    
.def	i2cstat	= r27									;  
;;
;=================;		   RC5 
;00110000 - TV											;     
;10110000 - Mute;
;01100100 - Sleep;
;00001000 - Volume up;
;10001000 - Volume down;
;00000100 - Channel up;
;10000100 - Channel down;
;=================;
.equ	INPUT	=0					    				;PD0 - ,   
.equ	SYS_ADDR=0										;   ( . =0);
.def	S		=R0;;
.def	inttemp	=R1;;
.def	ref1	=R2;;
.def	ref2	=R3;;
.def	temp	=R16;;
.def	timerL	=R17;;
.def	timerH	=R16;;
.def	system	=R19;;
.def	command	=R20									;,      ;
.def	bitcnt	=R21;;
;=================; 
.def	data		=r29;     I2C
.def	addr		=r25;     I2C
.def	lcd_count	=r24;  
.def	vol_left	=r9;  
.def	vol_right	=r8;  
.def	vol_left_front	=r7;  
.def	vol_right_front	=r7;  
.def	vol_treble		=r6;  
.def	vol_bass		=r5;  
.def	audio			=r4;
.def	vol_all			=r10; 
;;
.org    0											;;
rjmp reset									;    ;
;;
;=================; ;
.org OVF0addr;;
TIM0_OVF:	;;
		in	S,sreg;;
		inc	timerL					;;
		inc	inttemp;;
		brne	TIM0_OVF_exit;;
		inc	timerH;;
;=================
TIM0_OVF_exit:;;
		out	sreg,S;;
		reti;;
;=================;  ;
initlcd:;;
	rcall ddelay;;
	rcall ddelay;;
	ldi addr,$30 		
	rcall icom_2313 		;;
	rcall delay;;
	ldi addr,$30 		
	rcall icom_2313 		;;
	rcall delay;;
	ldi addr,$30 		
	rcall icom_2313 		;;
	rcall ddelay;;
;;
	ldi	addr,0b00101000 	
	rcall icom_2313 		
;;
	ldi addr,0b00001100		
	rcall icom_2313;;
		;;
	ldi addr,0b00000110 	
	rcall icom_2313		;;
;;
	ldi addr,0b00000010 	   ;
	rcall icom_2313;;
;;
ret							
;=================;  ;
reset:;;
	ldi temp,low(RAMEND)					 ; ;
	out	SPL,temp			;;
	ldi	temp,1								 ;/ 0   ;
	out	TCCR0,temp;;
	ldi	temp,1<<TOIE0						 ;    ;
	out	TIMSK,temp;;
;;
    ser data            				 	 ;  B  ;
    out ddrb,data;;
  	ldi data,0b01111110	;;
    out ddrd,data 						     ;  D   (1,2,3,6 );
 	ldi data,0b01001110						 ;  D   (1,2,3,6 );
    out portd,data;;
    rcall initlcd							 ;   ;
sei	;  
;=================;      , ,   ..
	ldi temp,0b01011000;;
	mov audio,temp
	ldi temp,0b00000111;;
	mov vol_left,temp;;
	mov vol_right,temp;;
	ldi temp,0b00000100;;
	mov vol_bass,temp;;
	mov vol_treble,temp;;
	ldi temp,0b00111000;;
	mov vol_all,temp;;
;      TDA7312
	ldi data,audio_addr;;
	or data,audio;;
	rcall i2c_trance;;
	ldi data,l_addr;;
	or data,vol_left;;
	rcall i2c_trance;;
	ldi data,r_addr;;
	or data,vol_right;
	rcall i2c_trance;;
	ldi data,treb_addr;;
	or data,vol_treble;;
	rcall i2c_trance;;
	ldi data,bass_addr;;
	or data,vol_bass;;
	rcall i2c_trance;;
	ldi data,vol_addr;;
	or data,vol_all;;
	rcall i2c_trance;;
;=================	 ;  ;
	rcall clean				; ;
	ldi r30,low(l_intro1*2)	;  Z    l_intro1;
    ldi r31,high(l_intro1*2);  1   ;
    ldi lcd_count,16 ;;
	rcall ddram;;
	ldi addr,0b11000000      ;   DDRAM    ;
    rcall icom_2313	;;
	ldi lcd_count,16 ;;
	ldi r30,low(l_intro2*2)  ;  Z    l_intro2;
    ldi r31,high(l_intro2*2) ;  2  ;
    rcall ddram;;
	rcall ddelay;;
;=================  ;
;=================; 
volume_all:								;   -    ;
	rcall clean				
	ldi r30,low(l_volume*2) 
    ldi r31,high(l_volume*2)			
    ldi lcd_count,10 ;;
	rcall ddram;;
	rcall delay				
;
volume_all_nc:				;   -     ;
	rcall clean_2;;
    mov temp,vol_all;;
	ldi data,0b00111111;;
	sub data,temp;;
	mov temp,data;;
cont:	;;
	cpi temp,0b00000100;;
	brlo volume_all_l;;
	asr temp;;
	asr temp;;
	brcc nmax_vol;;
	inc temp;;
nmax_vol:;;
mov lcd_count,temp;;
ldi r30,low(l_bar*2)    						
ldi r31,high(l_bar*2);;
rcall ddram;;
;
volume_all_l:;  -    ,     
rcall scan								;;
cpi command,0b00010000;;
breq vol_all_down;;
cpi command,0b00010001;;
breq vol_all_up;;
cpi command,0b00001100;;
breq treble;;
cpi command,0b00100000;;
breq vol_all_channel_up;;
cpi command,0b00100001;;
breq vol_all_channel_down;;
rjmp volume_all_l
;
vol_all_channel_up:; 
	rcall channel_up;
	rjmp volume_all;;
vol_all_channel_down:; 
	rcall channel_down;;
;
vol_all_up:	;; 
	ldi temp,0b00111111;;
	cp vol_all,temp;;
	breq vol_all_trance;;
	inc vol_all;;
	rjmp vol_all_trance;;
vol_all_down:; 
	ldi temp,0b00000000;;
	cp vol_all,temp;;
	breq vol_all_trance	;;
	dec vol_all;;
	rjmp vol_all_trance;;
vol_all_trance:	;   TDA7312
	ldi data,vol_addr;;
	or data,vol_all;;
	rcall i2c_trance;;
;;
rjmp volume_all_nc;;
;=================;   " "
wtembr:
	ldi r30,low(l_tembr*2) 
    ldi r31,high(l_tembr*2)				;;
    ldi lcd_count,6 ;;
	rcall ddram;;
ret;;
;=================;  
treble:						;  -    
	rcall clean				
	rcall wtembr			
	ldi r30,low(l_treble*2) 
    ldi r31,high(l_treble*2)				;;
    ldi lcd_count,7 ;;
	rcall ddram;;
	rcall delay				
							
treble_nc:					;  -     
	rcall clean_2;;
 	mov temp,vol_treble;;
;;
	ldi data,0b00001111;;
	sub data,temp;
	mov temp,data;
;;
	cpi temp,0;
	breq treble_l;
	mov lcd_count,temp
	ldi r30,low(l_bar*2) 
    ldi r31,high(l_bar*2);
	rcall ddram;;
;
treble_l:;  -    ,     
	rcall scan	;;
	cpi command,0b00010000;;
	breq treble_down;;
	cpi command,0b00010001;;
	breq treble_up;;
	cpi command,0b00001100;;
	breq bass;;
    cpi command,0b00100000;;
	breq treble_channel_up;;
    cpi command,0b00100001;;
	breq treble_channel_down;;
;
rjmp treble_l;;
;
treble_channel_up:;  -  
	rcall channel_up;;
	rjmp treble;;
treble_channel_down:; 
	rcall channel_down;;
	rjmp treble;;
;;
treble_up:	;;  - 
	ldi temp,0b00001111;;
	cp vol_treble,temp;;
	breq treble_trance;;
	inc vol_treble;;
	rjmp treble_trance;;
;;
treble_down:;;  - 
	ldi temp,0b00000000;;
	cp vol_treble,temp;;
	breq treble_trance	;;
	dec vol_treble;;
	rjmp treble_trance;;
;;
treble_trance:;	  -   TDA7312
	ldi data,treb_addr;;
	or data,vol_treble;;
	rcall i2c_trance;;
;;
rjmp treble_nc;;
;=================;   -    -   
volume_all_to:
rjmp volume_all
;=================;   
bass:								;  -    
	rcall clean				
	rcall wtembr;;
	ldi r30,low(l_bass*2) 
    ldi r31,high(l_bass*2)		
    ldi lcd_count,7 ;;
	rcall ddram;;
	rcall delay			
						;;
bass_nc:	;  -     
	rcall clean_2;;
	mov temp,vol_bass;;
;;
	ldi data,0b00001111;;
	sub data,temp;;
	mov temp,data;;
;;
	cpi temp,0;;
	breq bass_l;;
	mov lcd_count,temp;;
	ldi r30,low(l_bar*2)    
    ldi r31,high(l_bar*2);;
	rcall ddram;;
;;
bass_l:;  -    ,     
	rcall scan								;;
	cpi command,0b00010000;;
	breq bass_down;;
	cpi command,0b00010001;;
	breq bass_up;;
	cpi command,0b00001100;;
	breq volume_all_to;;
    cpi command,0b00100000;;
	breq bass_channel_up;;
    cpi command,0b00100001;;
	breq bass_channel_down;;
rjmp bass_l;;
;;
bass_channel_up:;   -  
	rcall channel_up;;
	rjmp bass;;
bass_channel_down:;   -  
	rcall channel_down;;
	rjmp bass;;
;
bass_up:	;;  - 
	ldi temp,0b00001111;;
	cp vol_bass,temp;;
	breq bass_trance;;
	inc vol_bass;;
	rjmp bass_trance;;
bass_down:;   - 
	ldi temp,0b00000000;;
	cp vol_bass,temp;;
	breq bass_trance	;;
	dec vol_bass;;
	rjmp bass_trance;;
bass_trance:;   -   TDA7312
	ldi data,bass_addr;;
	or data,vol_bass;;
	rcall i2c_trance;;
rjmp bass_nc;;
;=================;  -   ""
wchannel:;;
	rcall clean;;
    ldi r30,low(l_channel*2)    					
    ldi r31,high(l_channel*2)					
    ldi lcd_count,6 ;;
	rcall ddram;;
ret;;
;=================;  
channel_up:	;   
	rcall wchannel;;
;;
	ldi temp,0b01011000;;
	or	temp,audio;;
	cpi temp,0b01011011;;
	breq up_to_zero;;
	inc audio;;
	rjmp channel;;
	up_to_zero:;;
	ldi temp,0b01011000;;
	and audio,temp	;;
	rjmp channel;;
channel_down:;    
	rcall wchannel;;
	ldi temp,0b01011000;;
	or	temp,audio;;
	cpi temp,0b01011000;;
	breq dec_to_zero;;
	dec audio;;
	rjmp channel;;
	dec_to_zero:;;
	ldi temp,0b01000011	;;
	or audio,temp;;
	rjmp channel;;
channel:;    
	ldi temp,0b01011000;;
	or	temp,audio;;
	cpi temp,0b01011000;;
	breq to1;;
	cpi temp,0b01011001;;
	breq to2;;
	cpi temp,0b01011010;;
	breq to3;;
	cpi temp,0b01011011;;
	breq to4;;
	rjmp to1
to4:;;
	ldi addr,$34					;4;
	rcall idat_2313;;
	rjmp channel_end;;
to3:;;
	ldi addr,$33					;3;
	rcall idat_2313;;
	rjmp channel_end;;
to2:;;
	ldi addr,$32					;2;
	rcall idat_2313;;
	rjmp channel_end;;
to1:;;
	ldi addr,$31					;1;
	rcall idat_2313;;
	rjmp channel_end;;
;;
channel_end:;    TDA7312
	ldi data,audio_addr;;
	or data,audio;;
	rcall i2c_trance;;
	ret												;
;=================;;s   ;
clean:										;     	
	ldi addr,0b10000000      				;;
    rcall icom_2313 ;;
	ldi lcd_count,16;;
	ldi r30,low(l_cln*2)    						
    ldi r31,high(l_cln*2)			;;
	rcall ddram;;
	ldi addr,0b10000000      				;;
    rcall icom_2313 	;;
	ret;;
;
clean_2:;;        
	ldi addr,0b11000000           				
    rcall icom_2313								
	ldi lcd_count,16;;
	ldi r30,low(l_cln*2)    						
    ldi r31,high(l_cln*2);;
	rcall ddram;;
	ldi addr,0b11000000           				
    rcall icom_2313	;;
	ret;;
;=================;		;        ATMEL
;(\Atmel\AVR Tools\AvrAssembler\Appnotes\avr410.asm)
detect:	clr	inttemp;;
		clr	timerH;;
detect1:clr	timerL;;
detect2:cpi	timerH,8					;If line not idle within 131ms;
		brlo	dl1;;
		rjmp	fault					;then exit;
dl1:	cpi	timerL,55					;If line low for 3.5ms;
		brge	start1					;then wait for start bit;
		sbis	PIND,INPUT				;If line is;
		rjmp	detect1					;low  - jump to detect1;
		rjmp	detect2					;high - jump to detect2;
start1:	cpi	timerH,8					;If no start bit detected;
		brge	fault					;within 130ms then exit;
		sbic	PIND,INPUT				;Wait for start bit;
		rjmp	start1;;
		clr	timerL					;Measure length of start bit;
start2:	cpi	timerL,17					;If startbit longer than 1.1ms,;
		brge	fault					;exit;
		sbis	PIND,INPUT;;
		rjmp	start2;;
								;Positive edge of 1st start bit;
		mov	temp,timerL				;timer is 1/2 bit time;
		clr	timerL;;
		mov	ref1,temp;;
		lsr	ref1;;
		mov	ref2,ref1;;
		add	ref1,temp				;ref1 = 3/4 bit time;
		lsl	temp;;
		add	ref2,temp				;ref2 = 5/4 bit time;
start3:	cp	timerL,ref1					;If high periode St2 &gt; 3/4 bit time
		brge	fault					;exit;
		sbic	PIND,INPUT				;Wait for falling edge start bit 2;
		rjmp	start3;;
		clr	timerL;;
		ldi	bitcnt,12					;Receive 12 bits;
		clr	command;;
		clr	system;;
sample:	cp	timerL,ref1					;Sample INPUT at 1/4 bit time;
		brlo	sample;;
		sbic	PIND,INPUT	;;
		rjmp	bit_is_a_1				;Jump if line high;
bit_is_a_0:	clc						;Store a '0';
		rol	command;;
		rol	system;;
								;Synchronize timing;
bit_is_a_0a:	cp	timerL,ref2				;If no edge within 3/4 bit time;
		brge	fault					;exit;
		sbis	PIND,INPUT				;Wait for rising edge;
		rjmp	bit_is_a_0a				;in the middle of the bit;
		clr	timerL;;
		rjmp	nextbit;;
bit_is_a_1:	sec						;Store a '1';
		rol	command;;
		rol	system;;
 	 							;Synchronize timing;
bit_is_a_1a:cp	timerL,ref2					;If no edge within 3/4 bit time;
		brge	fault					;exit;
		sbic	PIND,INPUT				;Wait for falling edge;
		rjmp	bit_is_a_1a				;in the middle of the bit;
		clr	timerL;;
nextbit:dec	bitcnt						;If bitcnt &gt; 0
		brne	sample					;get next bit;
								;All bits sucessfully received!;
		mov	temp,command				;Place system bits in "system";
		rol	temp		;;
		rol	system;;
		rol	temp;;
		rol	system;;
		bst	system,5					;Move toggle bit;
		bld	command,6				;to "command";
								;Clear remaining bits;
		andi	command,0b01111111;;
		andi	system,0x1F;;
		ret;;
fault:	ser	command					;Both "command" and "system";
		ser	system					;0xFF indicates failure;
		ret;;
;=================;   
scan:	;; 
	ldi command,0;;
	sbis pind,1;;
	ldi command,0b00100110 ;;
	sbis pind,2;;
	ldi command,0b00010000  ;;
	sbis pind,3;;
	ldi command,0b00010001 ;;
	sbis pind,6;;
	ldi command,0b00001100 ;;
	cpi command,0;;
	breq scan_rc5;;
	rcall delay;;
ret;;
;
scan_rc5:;;   RC5
	rcall detect;;
	andi command,0x3F					
	cpi command,0x3f;;
	breq scan;;
ret	;;
;=================;  
ddelay:; 
        ldi r19,5;;
dd:		rcall delay;;
        dec r19;;
        brne dd;;
        ret	;;
del:	; 
        ldi r18,50            			
l4:     dec r18                 			;;
        brne l4                 			;;
        ret;;
delay:;  
        ldi r17,50             			
l:      ldi r18,255             			;;
l1:     dec r18                 ;;
        brne l1                 ;;
        dec r17                 ;;
        brne l                  ;;
        ret;;
;=================; ;    
; (     Atmel - www.atmel.ru)
ddram:	;;   
cli;;
	lpm		                     	
    mov addr,r0;;
    rcall idat_2313        					
    rcall del;;
    ld r1,z+               							
    dec lcd_count                 				
    brne ddram  ;;
sei	            							;;
ret    

icom_2313:;;   
    swap addr               							
    mov r26,addr;;
    andi r26,$ef            							
    ori  r26,$e0            						
;;
	out portb,r26	;;
    cbi portb, 5            							
    swap addr                						
    mov r26,addr;;
    andi r26,$ef            						
    ori  r26,$e0            						
;;
    out portb,r26;;
    cbi portb, 5            						
	rcall del;;
    ret;;
;;
idat_2313:;   
    swap addr  			     							
    mov r26,addr	;;
    ori  r26,$f0        	 		   				
;;
	out portb,r26           						
    cbi portb,5           							
    swap addr             	 		   			 	
    mov r26,addr		;;
    ori  r26,$f0       	 	 						
;;
    out portb,r26      		   						
    cbi portb,5             						
	rcall del		;;
    ret;;
;=================; ;  I2C	
;     ATMEL
;(\Atmel\AVR Tools\AvrAssembler\Appnotes\avr410.asm)
i2c_trance:;  
;;
	ldi	i2cadr,0b10001000;  .         .
	rcall	i2c_start				

	mov	i2cdata,data			
	rcall	i2c_do_transfer		
	rcall	i2c_stop			
ret;;
;=================;	;
i2c_hp_delay:;;
	ldi	i2cdelay,2;;
i2c_hp_delay_loop:;;
	dec	i2cdelay;;
	brne	i2c_hp_delay_loop;;
	ret;;
i2c_qp_delay:;;
	ldi	i2cdelay,1	;;
i2c_qp_delay_loop:;;
	dec	i2cdelay;;
	brne	i2c_qp_delay_loop;;
	ret;;
i2c_rep_start:;;
	sbi	DDRD,SCLP				; force SCL low;
	cbi	DDRD,SDAP				; release SDA;
	rcall	i2c_hp_delay		; half period delay;
	cbi	DDRD,SCLP				; release SCL;
	rcall	i2c_qp_delay		; quarter period delay;
i2c_start:				;;
	mov	i2cdata,i2cadr			; copy address to transmitt register;
	sbi	DDRD,SDAP				; force SDA low;
	rcall	i2c_qp_delay		; quarter period delay;
i2c_write:;;
	sec							; set carry flag;
	rol	i2cdata					; shift in carry and out bit one;
	rjmp	i2c_write_first;;
i2c_write_bit:;;
	lsl	i2cdata					; if transmit register empty;
i2c_write_first:;;
	breq	i2c_get_ack			; goto get acknowledge;
	sbi	DDRD,SCLP				; force SCL low;
	brcc	i2c_write_low		; if bit high;
	nop							; (equalize number of cycles);
	cbi	DDRD,SDAP				; release SDA;
	rjmp	i2c_write_high;;
i2c_write_low:					; else;
	sbi	DDRD,SDAP				; force SDA low;
	rjmp	i2c_write_high		; (equalize number of cycles);
i2c_write_high:;;
	rcall	i2c_hp_delay		; half period delay;
	cbi	DDRD,SCLP				; release SCL;
	rcall	i2c_hp_delay		; half period delay;
	rjmp	i2c_write_bit;;
i2c_get_ack:;;
	sbi	DDRD,SCLP				; force SCL low;
	cbi	DDRD,SDAP				; release SDA;
	rcall	i2c_hp_delay		; half period delay;
	cbi	DDRD,SCLP				; release SCL;
i2c_get_ack_wait:;;
	sbis	PIND,SCLP			; wait SCL high ;
								;(In case wait states are inserted);
	rjmp	i2c_get_ack_wait;;
	clc							; clear carry flag;
	sbic	PIND,SDAP			; if SDA is high;
	sec							; set carry flag;
	rcall	i2c_hp_delay		; half period delay;
	ret;;
i2c_do_transfer:;;
	sbrs	i2cadr,b_dir		; if dir = write;
	rjmp	i2c_write			;goto write data;
i2c_read:;;
	rol	i2cstat					; store acknowledge;
								; (used by i2c_put_ack);
	ldi	i2cdata,0x01			; data = 0x01;
i2c_read_bit:					; do;
	sbi	DDRD,SCLP				; force SCL low;
	rcall	i2c_hp_delay		; half period delay;
	cbi	DDRD,SCLP				; release SCL;
	rcall	i2c_hp_delay		; half period delay;
	clc							; clear carry flag;
	sbic	PIND,SDAP			; if SDA is high;
	sec							; set carry flag;
	rol	i2cdata					; store data bit;
	brcc	i2c_read_bit		; while receive register not full;
i2c_put_ack:;;
	sbi	DDRD,SCLP				; force SCL low;
	ror	i2cstat					; get status bit;
	brcc	i2c_put_ack_low		; if bit low goto assert low;
	cbi	DDRD,SDAP				; release SDA;
	rjmp	i2c_put_ack_high;;
i2c_put_ack_low:				; else;
	sbi	DDRD,SDAP				; force SDA low;
i2c_put_ack_high:;;
	rcall	i2c_hp_delay		; half period delay;
	cbi	DDRD,SCLP				; release SCL;
i2c_put_ack_wait:;;
	sbis	PIND,SCLP			; wait SCL high;
	rjmp	i2c_put_ack_wait;;
	rcall	i2c_hp_delay		; half period delay;
	ret;;
i2c_stop:;;
	sbi	DDRD,SCLP				; force SCL low;
	sbi	DDRD,SDAP				; force SDA low;
	rcall	i2c_hp_delay		; half period delay;
	cbi	DDRD,SCLP				; release SCL;
	rcall	i2c_qp_delay		; quarter period delay;
	cbi	DDRD,SDAP				; release SDA;
	rcall	i2c_hp_delay		; half period delay;
	ret;;
i2c_init:;;
;;
	ldi i2cstat,0b01111110;;
	out	DDRD,i2cstat;;
;;
	clr	i2cstat				;;
	out	PORTD,i2cstat		; set I2C pins to open colector;
;;
;;
	ret;;
;=================;;  (    )
.org $300;;
l_cln:		.DB ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ';;    80 
			.DB ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ';;
			.DB ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ';;
			.DB ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ';;
			.DB ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ';;
;;
l_bar:		.DB '*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*';;   16  "*"
;;
l_intro1:	.DB '"','H','O','B','A',$b1,' ','T','E','X','H',$a5,'K','A','"',' ';;" "
l_intro2:	.DB 'C','T','E','P','E','O','T','E','M',$a0,'P','O',$a0,$a7,'O','K';;""
			;;
l_volume:	.DB $a1,'P','O','M','K','O','C','T','b',' ',' ',' ',' ',' ',' ',' ';;""
l_tembr	:	.DB 'T','E','M',$a0,'P',' ',' ',' ';;""
l_bass	:	.DB 'H',$a5,$a4,'K',$a5,'E',' ',' ';;""
l_treble:	.DB 'B',$ae,'C','O','K',$a5,'E',' ';;""
l_channel:  .DB 'K','A','H','A',$a7,' ',' ',' ';;""
