.include "tn2313def.inc"		;  - ATTiny2313
.equ       hex = 16	
;=================	; I2C
	;  I2C
.equ	SCLP	= 5		;  SCL 
.equ	SDAP	= 4	;  SDA 
.equ	b_dir	= 0	;     i2cadr
.equ	i2crd	= 1	
.equ	i2cwr	= 0	
	; 
.def	i2cdelay = r22		; 
.def	i2cdata	= r23	;   I2C
.def	i2cadr	= r24		;    I2C
.def	i2cstat	= r27		;   I2C
;=================	; RC5
	
.equ	INPUT	= 0			;,        - PD0
.equ	SYS_ADDR = 0		;   ( . =0)
.def	S = R0	;  RC5 -  . 
.def	inttemp	= R1	
.def	ref1	= R2	
.def	ref2	= R3	
.def	temp	= R16	
.def	timerL	= R17	
.def	timerH	= R16	
.def	system	= R19	
.def	command =R20			;,       ()
.def	bitcnt	= R21	
;=================	
.org    0	; 
rjmp reset	;   
;=================	;   
.org OVF0addr	
TIM0_OVF:		
in	S,sreg	
inc	timerL		
inc	inttemp	
brne	TIM0_OVF_exit	
inc	timerH	
TIM0_OVF_exit:	
out	sreg,S	
reti	
;=================	;  
initlcd:	
rcall ddelay	; 
rcall ddelay	
ldi 	r25,$30 			;  1
rcall 	icom_2313 			;8-   , 1, 58 
rcall 	delay	; 
ldi 	r25,$30 			;  2 
rcall 	icom_2313 			;    
rcall 	delay	
ldi 	r25,$30 			;  3
rcall 	icom_2313 			
rcall 	ddelay	
ldi 	r25,0b00101000 		;4-  , 2- , 58 
rcall 	icom_2313 			
ldi 	r25,0b00001100		
rcall 	icom_2313	
ldi 	r25,0b00000110 		; ,  
rcall 	icom_2313			
ldi 	r25,0b00000010 	      	;  DDRAM,  ,        DDRAM,   AC = 0
rcall 	icom_2313	
ret	;  
;=================	
reset:	;  .      
ldi temp,low(RAMEND)		; 
out	SPL,temp	
ldi	temp,1		;/ 0   
out	TCCR0,temp	
ldi	temp,1<<TOIE0		;    
out	TIMSK,temp	
;=================	
ldi r25,$ff 	;  B  
out ddrb,r25	
ldi r25,0b01001110	;  D   (1,2,3,6 )
out ddrd,r25	
out portd,r25	
rcall initlcd	;   
rcall i2c_init	;   I2C
		
ldi r29,0b00001000	;     TDA8425
ldi r30,0b11011111	;    TDA8425
mov r4,r30	;     r4
rcall i2c_trance	;   r30   I2C  TDA8425   r29
	; ,  ,  
rcall del	; 
	
ldi r29,0b00000000	;    TDA8425
ldi r30,0b11100000	;  - 224
rcall i2c_trance	;   r30   I2C  TDA8425   r29
ldi r29,0b00000001	;    TDA8425
rcall i2c_trance	;   r30   I2C  TDA8425   r29
	
ldi temp,0b11100000	;    - 224
mov r7,temp	;r7 -  
mov r8,temp	;r8 -  
mov r9,temp	;r9 -  
sei	;  
;=================	; 
rcall clean		; 
ldi r30,low(l_intro1*2) 	;  Z    l_intro1
ldi r31,high(l_intro1*2)	 
ldi r24,16 	;   - 16
rcall ddram	;      DDRAM 
		; 1  
ldi r25,0b11000000		;   DDRAM   2 
rcall icom_2313		
ldi r24,16 	;   - 16
ldi r30,low(l_intro2*2)    	;  Z    l_intro2
ldi r31,high(l_intro2*2)	;  2  
rcall ddram	; 2  
rcall ddelay	
;=================	; 
volume_both:	;  - " "
rcall clean	
ldi r30,low(l_volume*2)	;  Z    l_volume
ldi r31,high(l_volume*2)			
ldi r24,10 	;   - 10
rcall ddram	;    ""
ldi r30,low(l_both*2) 	;  Z    l_both
ldi r31,high(l_both*2)	
ldi r24,6	;   - 6
rcall ddram	;  ""
  	
mov r29,r9	;    r9    r29    I2C
rcall delay	
volume_both_nc:	; 
rcall wbar	; ,        
	
volume_both_l:	; 
rcall scan	;   /   RC5
cpi command,0b00010000	;     0b00010000
breq vbu	; ,    
cpi command,0b00010001	;     0b00010001
breq vbd	; ,    
cpi command,0b00001100	;     0b00001100
breq volume_right	; ,     
cpi command,0b00100110	;     0b00100110
breq sw_cb	; ,    
rjmp volume_both_l	;   volume_both_l
	
sw_cb:	; 
rcall sw_channel	;  
rjmp volume_both	;   volume_both
	
vbu:		; 
rcall volume_up	;  ,   
rjmp vbi	;   vbi
vbd:	; 
rcall volume_down	;  ,   
rjmp vbi	;   vbi
vbi:		; 
mov r9,r29	;       r9	
ldi r29,0b00000000	;    TDA8425
mov r30,r9	;  - r9
rcall i2c_trance	;       I2C  TDA8425
ldi r29,0b00000001	;    TDA8425
rcall i2c_trance	;       I2C  TDA8425
mov r29,r9	;   r29   r9
rjmp volume_both_nc	;   volume_both_nc
;=================	
volume_right:		;  - " "
rcall clean		
ldi r30,low(l_volume*2)    	
ldi r31,high(l_volume*2)	
ldi r24,10 	
rcall ddram	
ldi r30,low(l_right*2)	
ldi r31,high(l_right*2)	
 ldi r24,6 	
rcall ddram	
	
mov r29,r8	
rcall delay	
volume_right_nc:	
rcall wbar	
	
volume_right_l:		
rcall scan	
cpi command,0b00010000	
breq vru	
cpi command,0b00010001	
breq vrd	
cpi command,0b00001100	
breq volume_left	
cpi command,0b00100110	
breq sw_cr	
rjmp volume_right_l	
	
sw_cr:	
rcall sw_channel	
rjmp volume_right	
	
vru:		
rcall volume_up	
rjmp vri	
vrd:	
rcall volume_down	
rjmp vri	
vri:		
mov r8,r29	
ldi r29,0b00000001	
mov r30,r8	
rcall i2c_trance	
mov r29,r8	
rjmp volume_right_nc	
	
volume_both_t: rjmp volume_both	; 
;=================	
volume_left:	;  - " "
rcall clean	
ldi r30,low(l_volume*2)    	
ldi r31,high(l_volume*2)	
ldi r24,10 	
rcall ddram	
ldi r30,low(l_left*2)		
ldi r31,high(l_left*2)		
ldi r24,6 	
rcall ddram	
	
mov r29,r7	
rcall delay		
volume_left_nc:	
rcall wbar	
	
volume_left_l:	
rcall scan	
cpi command,0b00010000	
breq vlu	
cpi command,0b00010001	
breq vld	
cpi command,0b00001100	
breq volume_both_t	
cpi command,0b00100110	
breq sw_cl	
rjmp volume_left_l	
	
sw_cl:	
rcall sw_channel	
rjmp volume_left	
	
vlu:		
rcall volume_up	
rjmp vli	
vld:	
rcall volume_down	
rjmp vli	
vli:		
mov r7,r29	
ldi r29,0b00000000	
mov r30,r7	
rcall i2c_trance	
mov r29,r7	
rjmp volume_left_nc	
;=================	
volume_up:	;  
cpi r29,0b11111111	;  
breq evu	;      
inc r29	;   r29  1
evu: ret	;  
;=================	
volume_down:	;  
cpi r29,0b11000000	;  
breq evd	;      
dec r29	;   r29  1
evd:ret	;  
;=================	
wbar:	;    -
ldi r25,0b11000000 	;   DDRAM    ( $64)
rcall icom_2313	;   
ldi r24,16	;    = 16
ldi r30,low(l_cln*2)   		;  Z    l_cln
ldi r31,high(l_cln*2)	
rcall ddram	;      DDRAM 
ldi r25,0b11000000		;   DDRAM    ( $64)
rcall icom_2313	;   
 	;    
mov temp,r29	;   -  temp  r29
andi temp,0b00111111	   	; "" temp  00111111
lsr temp	;    temp
lsr temp	;    temp
cpi temp,0	; temp  0
breq empt	; temp = 0     empt
inc temp	;   temp  1
mov r24,temp	;       temp
	
ldi r30,low(l_bar*2)	;  Z    l_bar
ldi r31,high(l_bar*2)	
rcall ddram	;  ,      r29 / 4
empt:	; empt
ret	;  
;=================	
sw_channel:		;   
rcall clean	;    
ldi r30,low(l_channel*2)    	;  Z    l_channel
ldi r31,high(l_channel*2)		
ldi r24,6 	;   = 6
rcall ddram	;    ""
		
bst r4,0	; 0   r4   T
brtc to2	;   = 0,    to2
rjmp to1	;    to1
to2:	; to2
ldi temp,0b00000001	;    temp  00000001
or r4,temp	; r4  temp
ldi r25,$32		;   r25  $32 (  "2"  )
rcall idat_2313	;   
rjmp swc_end	;   swc_end
to1:	; to1
ldi temp,0b11111110	;    temp  11111110
and r4,temp	; r4  temp
ldi r25,$31		;   r25  $31 (  "1"  )
rcall idat_2313	;   
rjmp swc_end	;   swc_end
swc_end:	; swc_end
ldi r29,0b00001000	;   r29  00001000
mov r30,r4	;  r4   r30 
rcall i2c_trance	;   i2 
rcall ddelay	; 
ret	;  
;=================	
clean:	;     
ldi r25,0b10000000      	
rcall icom_2313 	
ldi r24,16	
ldi r30,low(l_cln*2)    	
ldi r31,high(l_cln*2)		
rcall ddram	
ldi r25,0b10000000      	
rcall icom_2313 		
ret	
; RC5	;        ATMEL
;(\Atmel\AVR Tools\AvrAssembler\Appnotes\avr410.asm)
detect:		
clr	inttemp	
clr timerH	
detect1:	
clr	timerL	
detect2:	
cpi	timerH,8	
brlo	dl1	
rjmp	fault	
dl1:		
cpi	timerL,55	
brge	start1	
sbis	PIND,INPUT		
rjmp	detect1	
rjmp	detect2	
start1:		
cpi	timerH,8	
brge	fault	
sbic	PIND,INPUT		
rjmp	start1	
clr	timerL	
start2:		
cpi	timerL,17	
brge	fault	
sbis	PIND,INPUT	
rjmp	start2	
			
mov	temp,timerL		
clr	timerL	
mov	ref1,temp	
lsr	ref1	
mov	ref2,ref1	
add	ref1,temp	
lsl	temp	
add	ref2,temp	
start3:		
cp	timerL,ref1	
brge	fault	
sbic	PIND,INPUT	
rjmp	start3	
clr	timerL	
ldi	bitcnt,12		
clr	command	
clr	system	
sample:		
cp	timerL,ref1	
brlo	sample	
sbic	PIND,INPUT		
rjmp	bit_is_a_1	
bit_is_a_0:			
clc	
rol	command	
rol	system	
				
bit_is_a_0a:		
cp	timerL,ref2	
brge	fault	
sbis	PIND,INPUT	
rjmp	bit_is_a_0a		
clr	timerL	
rjmp	nextbit	
bit_is_a_1:			
sec	
rol	command	
rol	system	
 	 			
bit_is_a_1a:	
cp	timerL,ref2	
brge	fault	
sbic	PIND,INPUT	
rjmp	bit_is_a_1a		
clr	timerL	
nextbit:		
dec	bitcnt	
brne	sample	
				
mov	temp,command		
rol	temp			
rol	system	
rol	temp	
rol	system	
bst	system,5		
bld	command,6	
		
andi command,0b01111111	
andi	system,0x1F	
ret	
fault:		
ser	command		
ser	system	
ret	
;=================	
	;     RC5
scan:		
rcall detect	
andi command,0x3F	
cpi command,0x3f	
breq scan	
ret	
;=================	
; 	
ddelay:	
ldi r19,10	
dd:		
rcall delay	
dec r19	
brne dd	
ret		
del:		
ldi r18,50     	
l4:			
dec r18                 	
brne l4                 			
ret	
delay:	
ldi r17,50    	
l:      				
ldi r18,255             	
l1:     	
dec r18                 	
brne l1                 	
dec r17                 	
brne l                  	
ret	
;=================	;    
	; (     Atmel - www.atmel.ru)
ddram:		;     
cli	;  
lpm				;  flash-  	
mov r25,r0	;  r0   r25
rcall idat_2313        	;     
rcall del	; 
ld r1,z+   	;  1  Z  flash-
dec r24       	;  r24
brne ddram  	;  ,   0 (  r24   0)
sei	            		;  
ret       			;  
;=================	
icom_2313:	;    
swap r25             			;    r25 
mov r26,r25	;  r25   r26
andi r26,$ef          		;  4  D ( RS=0)
ori  r26,$e0   	;  5  D (  E=1)
out portb,r26		;    
cbi portb, 5            		;   5  D ( E=0). 
swap r25          			;   r25 
mov r26,r25	;  r25   r26
andi r26,$ef         	;  4  D ( RS=0)	
ori  r26,$e0        	;  5  D (  E=1)
out portb,r26	;    
cbi portb, 5       			;   5  D (  E=0)
rcall del	; 
ret	;  
idat_2313:	;    
swap r25  	;    r25 
mov r26,r25		;  r25   r26
ori  r26,$f0    	;  4  D ( RS=1)
out portb,r26       			;  5  D (  E=1)
cbi portb,5       	;   5  D (  E=0)
swap r25      	;    r25 
mov r26,r25			;  r25   r26
ori  r26,$f0     	;  4  D ( RS=1)
out portb,r26   	;  5  D (  E=1)
cbi portb,5     			;   5  D (  E=0)
rcall del			; 
ret	
;  I2C	;     ATMEL
;(\Atmel\AVR Tools\AvrAssembler\Appnotes\avr410.asm)
i2c_trance:	
ldi	i2cadr,0b10000010	
rcall	i2c_start		
	
mov	i2cdata,r29	
rcall	i2c_do_transfer		
	
mov	i2cdata,r30		
rcall	i2c_do_transfer		
rcall	i2c_stop			
ret	
	
i2c_hp_delay:	
ldi	i2cdelay,2	
i2c_hp_delay_loop:	
dec	i2cdelay	
brne	i2c_hp_delay_loop	
ret	
i2c_qp_delay:	
ldi	i2cdelay,1		
i2c_qp_delay_loop:	
dec	i2cdelay	
brne	i2c_qp_delay_loop	
ret	
i2c_rep_start:	
sbi	DDRD,SCLP		
cbi	DDRD,SDAP		
rcall	i2c_hp_delay		
cbi	DDRD,SCLP		
rcall	i2c_qp_delay		
i2c_start:			
mov	i2cdata,i2cadr		
sbi	DDRD,SDAP		
rcall	i2c_qp_delay		
i2c_write:	
sec				
rol	i2cdata			
rjmp	i2c_write_first	
i2c_write_bit:	
lsl	i2cdata			
i2c_write_first:	
breq	i2c_get_ack		
sbi	DDRD,SCLP		
brcc	i2c_write_low		
nop				
cbi	DDRD,SDAP		
rjmp	i2c_write_high	
i2c_write_low:		
sbi	DDRD,SDAP		
rjmp	i2c_write_high		
i2c_write_high:	
rcall	i2c_hp_delay		
cbi	DDRD,SCLP		
rcall	i2c_hp_delay		
rjmp	i2c_write_bit	
i2c_get_ack:	
sbi	DDRD,SCLP		
cbi	DDRD,SDAP		
rcall	i2c_hp_delay		
cbi	DDRD,SCLP		
i2c_get_ack_wait:	
sbis	PIND,SCLP		
			
rjmp	i2c_get_ack_wait	
clc				
sbic	PIND,SDAP		
sec			
rcall	i2c_hp_delay		
ret	
i2c_do_transfer:	
sbrs	i2cadr,b_dir		
rjmp	i2c_write		
i2c_read:	
rol	i2cstat		
				
ldi	i2cdata,0x01		
i2c_read_bit:			
sbi	DDRD,SCLP	
rcall	i2c_hp_delay		
cbi	DDRD,SCLP		
rcall	i2c_hp_delay		
clc				
sbic	PIND,SDAP		
sec				
rol	i2cdata			
brcc	i2c_read_bit		
i2c_put_ack:	
sbi	DDRD,SCLP		
ror	i2cstat			
brcc	i2c_put_ack_low		
cbi	DDRD,SDAP		
rjmp	i2c_put_ack_high	
i2c_put_ack_low:		
sbi	DDRD,SDAP		
i2c_put_ack_high:	
rcall	i2c_hp_delay		
cbi	DDRD,SCLP		
i2c_put_ack_wait:	
sbis	PIND,SCLP		
rjmp	i2c_put_ack_wait	
rcall	i2c_hp_delay		
ret	
i2c_stop:	
sbi	DDRD,SCLP		
sbi	DDRD,SDAP		
rcall	i2c_hp_delay		
cbi	DDRD,SCLP		
rcall	i2c_qp_delay		
cbi	DDRD,SDAP	
rcall	i2c_hp_delay		
ret	
i2c_init:	
ldi i2cstat,0b00110000	
out	DDRD,i2cstat	
clr	i2cstat			
out	PORTD,i2cstat		
ret	
.org $200	;  (    )
l_cln: .DB ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '	;  80  
.DB ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '	
.DB ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '	
.DB ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '	
.DB ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '	
	
l_bar: .DB '*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*'	;  16  "*"
	
l_intro1:	.DB '"','H','O','B','A',$b1,' ','T','E','X','H',$a5,'K','A','"',' '	; " "
	
l_intro2:	.DB 'C','T','E','P','E','O','T','E','M',$a0,'P','O',$a0,$a7,'O','K'	; ""
				
l_volume: .DB $a1,'P','O','M','K','O','C','T','b',' ',' ',' ',' ',' ',' ',' '	; ""
l_both: .DB 'O',$a0,'A',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '	; ""
l_right: .DB $a8,'P','A','B',$ae,$a6,' ',' ',' ',' ',' ',' ',' ',' ',' ',' '	; ""
l_left: .DB $a7,'E','B',$ae,$a6,' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '	; ""
	
l_channel: .DB 'K','A','H','A',$a7,' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '  	; ""
