.include "tn2313def.inc"		;  - ATTiny2313
;=================	; -  .
.equ v_addr = 0b00000000	; 
.equ head_addr = 0b00000111	;
.equ loud_addr = 0b00001001	;
.equ scart_addr = 0b00001000	;
;=================	; I2C
	;  I2C
.equ	SCLP	= 5		;  SCL 
.equ	SDAP	= 4	;  SDA 
.equ	b_dir	= 0	;     i2cadr
.equ	i2crd	= 1	
.equ	i2cwr	= 0	
	; 
.def	i2cdelay = r22		; 
.def	i2cdata	= r23	;   I2C
.def	i2cadr	= r24		;    I2C
.def	i2cstat	= r27		;   I2C
;=================	; RC5
.equ	INPUT	= 0			;,        - PD0
.equ	SYS_ADDR = 0		;   ( . =0)
.def	S = R0	;  RC5 -  . 
.def	inttemp	= R1	
.def	ref1	= R2	
.def	ref2	= R3	
.def	temp	= R16	
.def	timerL	= R17	
.def	timerH	= R16	
.def	system	= R19	
.def	command = R20			;,       ()
.def	bitcnt	= R21	
	
.def	data =r29	
.def	addr =r25	
.def	lcd_count =r24	
.def	vol_both =r9
.def	stat =r4	
;=================	
.org    0	; 
rjmp reset	;   
;=================	; 
.org OVF0addr	
TIM0_OVF:		
in	S,sreg	
inc	timerL		
inc	inttemp	
brne	TIM0_OVF_exit	
inc	timerH	
TIM0_OVF_exit:	
out	sreg,S	
Reti	
;=================	;  
initlcd:	
rcall ddelay	; 
rcall ddelay	
ldi 	r25,$30 			;  1
rcall 	icom_2313 		;8-   , 1, 58 
rcall 	delay	; 
ldi 	r25,$30 			;  2 
rcall 	icom_2313 		;    
rcall 	delay	
ldi 	r25,$30 			;  3
rcall 	icom_2313 			
rcall 	ddelay	
ldi 	r25,0b00101000 		;4-  , 2- , 58 
rcall 	icom_2313 			
ldi 	r25,0b00001100		
rcall 	icom_2313	
ldi 	r25,0b00000110 		; ,  
rcall 	icom_2313			
ldi 	r25,0b00000010 	      	;  DDRAM,  ,        DDRAM,   AC = 0
rcall 	icom_2313	
ret	;  
;=================	
reset:	;  .      
ldi temp,low(RAMEND)		; 
out	SPL,temp	
ldi	temp,1		;/ 0   
out	TCCR0,temp	
ldi	temp,1<<TOIE0		;    
out	TIMSK,temp	
;=================	
ser data            			;  B  
out ddrb,data	
ldi data,0b01111110		
out ddrd,data 			     	;  D   (1,2,3,6 )
ldi data,0b01001110			
out portd,data	
rcall initlcd				;   
sei		;  
;=================	;     
ldi addr,0b00000000	;    
rcall i2c_rd	;     I2C   
rcall delay	;
	;     
ldi addr,loud_addr	
rcall i2c_rd	;    I2C   
mov stat,i2cdata	;     
rcall delay	
ldi temp,0b01111000	
or stat,temp	
ldi temp,0b01111111	
and stat,temp
	
ldi addr,v_addr	
rcall i2c_rd	;    I2C   
mov vol_both,i2cdata	;     
rcall delay	
	
ldi temp,0b11000000	
or vol_both,temp	

	
;=================	; 
rcall clean				; 
ldi r30,low(l_intro1*2)		;  Z    l_intro1
ldi r31,high(l_intro1*2)	 
ldi lcd_count,16 	;   - 16
rcall ddram	;      DDRAM 
	; 1  
ldi addr,0b11000000      	;   DDRAM   2 
rcall icom_2313		
ldi lcd_count,16 	;   - 16
ldi r30,low(l_intro2*2)  	;  Z    l_intro2
ldi r31,high(l_intro2*2) 	;  2  
rcall ddram	; 2  
	
rcall ddelay	
;=================	; 
volume_both:			;  - " "
rcall clean		
ldi r30,low(l_volume*2) 	;  Z    l_volume
ldi r31,high(l_volume*2)			
ldi lcd_count,10 	;   - 10
rcall ddram	;    ""
rcall delay				
volume_both_nc:	
rcall clean_2	
	
dt1:mov temp,vol_both	;   temp  
cont:		
andi temp,0b00111111	;   temp 0b00111111
cpi temp,0b000000100	;  temp 0b00000100
brlo volume_both_l	;   ,    volume_both_l
asr temp	;    temp
asr temp	;    temp
brcc nmax_vol	;   ,    nmax_vol
inc temp	;  temp
nmax_vol:	
mov lcd_count,temp	;   temp  lcd_count
ldi r30,low(l_bar*2)    			;  Z    l_bar
ldi r31,high(l_bar*2)	
rcall ddram	;     
	
volume_both_l:	
rcall scan				;   /   RC5
cpi command,0b00010000	;     0b00010000
breq vb_up	; ,    
cpi command,0b00010001	;     0b00010001
breq vb_down	; ,    
cpi command,0b00001100	;     0b00001100
breq to_save	; ,     
cpi command,0b00100110	;     0b00100110
breq vb_sw_c	; ,    
cpi command,0b00001101	;     0b00001101
breq vb_mute	; ,   / 
rjmp volume_both_l	;   volume_both_l
	
vb_sw_c:			; 
rcall sw_channel	;  
rjmp volume_both	;   volume_both
	
vb_mute:		;/ 
rcall sw_mute	;  
rjmp volume_both	;   volume_both
	
to_save:	; 
rcall vol_mem	;    
rjmp volume_both	;   volume_both
	
vb_up:		; 
ldi temp,0b11111111	;     0b11111111
cp vol_both,temp	;  vol_both  temp
breq vb_trance	; ,    vb_trance
inc vol_both	;  vol_both
rjmp vb_trance	;   vb_trance
vb_down:	; 
ldi temp,0b11000000	;     0b11000000
cp vol_both,temp	;  vol_both  temp
breq vb_trance		; ,    vb_trance
dec vol_both	;  vol_both
rjmp vb_trance	;   vb_trance
	
vb_trance:				
rcall vol_audio	;       TDA9860
rjmp volume_both_nc	;   volume_both_nc
	
vol_mem:	;      
ldi addr,v_addr	;    addr  v_addr -   
mov data,vol_both	;    data  vol_both -  
rcall i2c_wr	;     I2C   
ret	;  
	
vol_audio:	;      TDA9860
mov data,vol_both	;    addr  v_addr -   
ldi addr,v_addr	;    data  vol_both -  
rcall i2c_trance	;     I2C  TDA9860
ret	;  
	
sw_channel:		; 
rcall clean	;   
ldi r30,low(l_channel*2)   	
ldi r31,high(l_channel*2)	
ldi lcd_count,6 	
rcall ddram	;    ""
		
bst stat,0	;    0   stat -  TDA9860 
brts to2	;  = 1,    to2
bst stat,1	;    1   stat -  TDA9860
brts to3	;  = 1,    to3
bst stat,2	;    2   stat -  TDA9860
brts to1	;  = 1,    to1
rjmp to1	;   to1
	
to3:	;      
ldi temp,0b00001000	;   temp  0b00000100
or stat,temp	;   temp   stat
ldi temp,0b10111000		;   temp  0b11111100
and stat,temp	;   temp   stat
ldi addr,'S'		;   addr   'S'
rcall idat_2313	;    3
rjmp swc_end	
	
to2:	;      
ldi temp,0b00001000	
or stat,temp	
ldi temp,0b10111101		
and stat,temp	
ldi addr,'R'
rcall idat_2313	
rjmp swc_end	
	
to1:	;      
ldi temp,0b00001000	
or stat,temp	
ldi temp,0b10111100
and stat,temp	
ldi addr,'L'
rcall idat_2313	
rjmp swc_end	
	
swc_end:	;   TDA9860   
 
mov data,stat	
ldi addr,loud_addr	
rcall i2c_trance	
	
mov data,stat	
ldi addr,loud_addr	
rcall i2c_wr	
	
rcall ddelay	
ret		;
	
sw_mute:		;/ 
rcall clean	; 
ldi r30,low(l_mute*2)	
ldi r31,high(l_mute*2)	
ldi lcd_count,6 	
rcall ddram	;  ""
bst stat,7	;    7   stat -  TDA9860 
brtc mute_off	;  = 0,    mute_off
rjmp mute_on	;   mute_off
	
mute_on:	; 
ldi temp,0b10111111	;   stat  0b01111111
and stat,temp		;   stat   temp
ldi r30,low(l_on*2)  	
ldi r31,high(l_on*2)	
ldi lcd_count,6 	
rcall ddram	;  ""
rjmp swc_end	
	
mute_off:	; 
ldi temp,0b01000000	
or stat,temp	
ldi r30,low(l_off*2)    		
ldi r31,high(l_off*2)		
ldi lcd_count,7 	
rcall ddram	;  ""
rjmp swc_end	
	
clean:		;     
ldi addr,0b10000000      		
rcall icom_2313 	
ldi lcd_count,16	
ldi r30,low(l_cln*2)    		
ldi r31,high(l_cln*2)			
rcall ddram	
ldi addr,0b10000000      		
 rcall icom_2313 		
ret	
	
clean_2:	;     ,   
ldi addr,0b11000000           		
rcall icom_2313				
ldi lcd_count,16	
ldi r30,low(l_cln*2) 	
ldi r31,high(l_cln*2)	
rcall ddram	
ldi addr,0b11000000 	
rcall icom_2313		
ret	
	
;RC5	;        ATMEL
;(\Atmel\AVR Tools\AvrAssembler\Appnotes\avr410.asm)
detect:		
clr	inttemp	
clr timerH	
detect1:	
clr	timerL	
detect2:	
cpi	timerH,8	
brlo	dl1	
rjmp	fault	
dl1:		
cpi	timerL,55	
brge	start1	
sbis	PIND,INPUT		
rjmp	detect1	
rjmp	detect2	
start1:		
cpi	timerH,8	
brge	fault	
sbic	PIND,INPUT		
rjmp	start1	
clr	timerL	
start2:		
cpi	timerL,17	
brge	fault	
sbis	PIND,INPUT	
rjmp	start2	
			
mov	temp,timerL		
clr	timerL	
mov	ref1,temp	
lsr	ref1	
mov	ref2,ref1	
add	ref1,temp	
lsl	temp	
add	ref2,temp	
start3:		
cp	timerL,ref1	
brge	fault	
sbic	PIND,INPUT	
rjmp	start3	
clr	timerL	
ldi	bitcnt,12		
clr	command	
clr	system	
sample:		
cp	timerL,ref1	
brlo	sample	
sbic	PIND,INPUT		
rjmp	bit_is_a_1	
bit_is_a_0:			
clc	
rol	command	
rol	system	
				
bit_is_a_0a:		
cp	timerL,ref2	
brge	fault	
sbis	PIND,INPUT	
rjmp	bit_is_a_0a		
clr	timerL	
rjmp	nextbit	
bit_is_a_1:			
sec	
rol	command	
rol	system	
 	 			
bit_is_a_1a:	
cp	timerL,ref2	
brge	fault	
sbic	PIND,INPUT	
rjmp	bit_is_a_1a		
clr	timerL	
nextbit:		
dec	bitcnt	
brne	sample	
				
mov	temp,command		
rol	temp			
rol	system	
rol	temp	
rol	system	
bst	system,5		
bld	command,6	
		
andi command,0b01111111	
andi	system,0x1F	
ret	
fault:		
ser	command		
ser	system	
ret	
;=================	
;     RC5	
scan:		
rcall detect	
andi command,0x3F	
cpi command,0x3f	
breq scan	
ret	
;=================	
; 	
ddelay:	
ldi r19,10	
dd:		
rcall delay	
dec r19	
brne dd	
ret		
del:		
ldi r18,50     	
l4:			
dec r18                 	
brne l4                 			
ret	
delay:	
ldi r17,50    	
l:      				
ldi r18,255             	
l1:     	
dec r18                 	
brne l1                 	
dec r17                 	
brne l                  	
ret	
;=================	
	;    
ddram:		; (     Atmel - www.atmel.ru)
cli	;     
lpm				;  
mov r25,r0	;  flash-  	
rcall idat_2313        	;  r0   r25
rcall del	;     
ld r1,z+   	; 
dec r24       	;  1  Z  flash-
brne ddram  	;  r24
sei	            		;  ,   0 (  r24   0)
ret       			;  
;=================	;  
icom_2313:	
swap r25             			;    
mov r26,r25	;    r25 
andi r26,$ef          		;  r25   r26
ori  r26,$e0   	;  4  D ( RS=0)
out portb,r26		;  5  D (  E=1)
cbi portb, 5            		;    
swap r25          			;   5  D ( E=0). 
mov r26,r25	;   r25 
andi r26,$ef         	;  r25   r26
ori  r26,$e0        	;  4  D ( RS=0)	
out portb,r26	;  5  D (  E=1)
cbi portb, 5       			;    
rcall del	;   5  D (  E=0)
ret	; 
idat_2313:	;  
swap r25  	;    
mov r26,r25		;    r25 
ori  r26,$f0    	;  r25   r26
out portb,r26       			;  4  D ( RS=1)
cbi portb,5       	;  5  D (  E=1)
swap r25      	;   5  D (  E=0)
mov r26,r25			;    r25 
ori  r26,$f0     	;  r25   r26
out portb,r26   	;  4  D ( RS=1)
cbi portb,5     			;  5  D (  E=1)
rcall del			;   5  D (  E=0)
ret	; 
	
;  I2C	
i2c_trance:	;     ATMEL
;(\Atmel\AVR Tools\AvrAssembler\Appnotes\avr410.asm)
ldi	i2cadr,0b10000000	
rcall	i2c_start		
	
mov	i2cdata,addr
rcall	i2c_do_transfer		
	
mov	i2cdata,data
rcall	i2c_do_transfer		
rcall	i2c_stop			
ret	

i2c_rd:
ldi		i2cadr,0b10100000	
rcall 	i2c_start			
mov		i2cdata,addr		
rcall 	i2c_do_transfer		
ldi		i2cadr,0b10100001	
rcall	i2c_rep_start		
sec							
rcall	i2c_do_transfer		
rcall	i2c_stop	
ret
	
i2c_wr:
ldi		i2cadr,0b10100000	
rcall 	i2c_start			
mov		i2cdata,addr		
rcall 	i2c_do_transfer		
mov		i2cdata,data		
rcall	i2c_do_transfer		
rcall	i2c_stop		
ret

i2c_hp_delay:	
ldi	i2cdelay,2	
i2c_hp_delay_loop:	
dec	i2cdelay	
brne	i2c_hp_delay_loop	
ret	
i2c_qp_delay:	
ldi	i2cdelay,1		
i2c_qp_delay_loop:	
dec	i2cdelay	
brne	i2c_qp_delay_loop	
ret	
i2c_rep_start:	
sbi	DDRD,SCLP		
cbi	DDRD,SDAP		
rcall	i2c_hp_delay		
cbi	DDRD,SCLP		
rcall	i2c_qp_delay		
i2c_start:			
mov	i2cdata,i2cadr		
sbi	DDRD,SDAP		
rcall	i2c_qp_delay		
i2c_write:	
sec				
rol	i2cdata			
rjmp	i2c_write_first	
i2c_write_bit:	
lsl	i2cdata			
i2c_write_first:	
breq	i2c_get_ack		
sbi	DDRD,SCLP		
brcc	i2c_write_low		
nop				
cbi	DDRD,SDAP		
rjmp	i2c_write_high	
i2c_write_low:		
sbi	DDRD,SDAP		
rjmp	i2c_write_high		
i2c_write_high:	
rcall	i2c_hp_delay		
cbi	DDRD,SCLP		
rcall	i2c_hp_delay		
rjmp	i2c_write_bit	
i2c_get_ack:	
sbi	DDRD,SCLP		
cbi	DDRD,SDAP		
rcall	i2c_hp_delay		
cbi	DDRD,SCLP		
i2c_get_ack_wait:	
sbis	PIND,SCLP		
			
rjmp	i2c_get_ack_wait	
clc				
sbic	PIND,SDAP		
sec			
rcall	i2c_hp_delay		
ret	
i2c_do_transfer:	
sbrs	i2cadr,b_dir		
rjmp	i2c_write		
i2c_read:	
rol	i2cstat		
				
ldi	i2cdata,0x01		
i2c_read_bit:			
sbi	DDRD,SCLP	
rcall	i2c_hp_delay		
cbi	DDRD,SCLP		
rcall	i2c_hp_delay		
clc				
sbic	PIND,SDAP		
sec				
rol	i2cdata			
brcc	i2c_read_bit		
i2c_put_ack:	
sbi	DDRD,SCLP		
ror	i2cstat			
brcc	i2c_put_ack_low		
cbi	DDRD,SDAP		
rjmp	i2c_put_ack_high	
i2c_put_ack_low:		
sbi	DDRD,SDAP		
i2c_put_ack_high:	
rcall	i2c_hp_delay		
cbi	DDRD,SCLP		
i2c_put_ack_wait:	
sbis	PIND,SCLP		
rjmp	i2c_put_ack_wait	
rcall	i2c_hp_delay		
ret	
i2c_stop:	
sbi	DDRD,SCLP		
sbi	DDRD,SDAP		
rcall	i2c_hp_delay		
cbi	DDRD,SCLP		
rcall	i2c_qp_delay		
cbi	DDRD,SDAP	
rcall	i2c_hp_delay		
ret	
i2c_init:	
ldi i2cstat,0b00110000	
out	DDRD,i2cstat	
clr	i2cstat			
out	PORTD,i2cstat		
ret	

.org $300	;  (    )
l_cln:	.DB ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '	;  80  
		.DB ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '	
		.DB ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '	
		.DB ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '	
		.DB ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '	
l_bar:  .DB '*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*'	;  16  "*"
	
l_intro1:	.DB '"','H','O','B','A',$b1,' ','T','E','X','H',$a5,'K','A','"',' '	; " "
l_intro2:	.DB 'C','T','E','P','E','O','T','E','M',$a0,'P','O',$a0,$a7,'O','K'	; ""
				
l_volume: .DB $a1,'P','O','M','K','O','C','T','b',' ',' ',' ',' ',' ',' ',' '	; ""
l_both:      .DB 'O',$a0,'A',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '	; ""
l_right:     .DB $a8,'P','A','B',$ae,$a6,' ',' ',' ',' ',' ',' ',' ',' ',' ',' '	; ""
l_left:        .DB $a7,'E','B',$ae,$a6,' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '	; ""
l_channel: .DB 'K','A','H','A',$a7,' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '  	; ""
l_mute	:	.DB $a4,'B',$a9,'K',' ','B',' ',' '	; ""
l_on	:	.DB 'K',$a7,$b0,$ab,'E','H',' ',' '	; ""
l_off	:	.DB $ae,'K',$a7,$b0,$ab,'E','H',' '	; ""
