$regfile = "m16def.dat"                                     '     ATmega16
$crystal = 8000000                                          '  

$baud = 9600                                                '   RS-232
$hwstack = 32                                               ' 
$swstack = 10                                               ' 
$framesize = 40                                             ' 

' 
Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7 , E = Portb.3 , Rs = Portb.2
Config Lcd = 16 * 2                                         ' 2   16 
Cursor Off                                                  ' 


'    /  
'TEMP_SENS________________________    
Config Pina.0 = Input                                       'TEMP_1
Temp_1 Alias Pina.0
Config Pina.1 = Input                                       'TEMP_2
Temp_2 Alias Pina.1

'ALARM_IN________________________      
Config Pina.2 = Input                                       'ALARM_IN
Alarm_in Alias Pina.2

'VALCODER________________________     ()
Config Pind.3 = Input                                       'Valcoder A INT1
Valcod_a Alias Pind.3
Config Pina.4 = Input                                       'Valcoder B
Valcod_b Alias Pina.4
Set Portd.3
Set Porta.4

'POWER_LED_______________________     
Config Pina.5 = Output                                      'A-LED1
Pow_led1 Alias Porta.5
Config Pina.6 = Output                                      'A-LED2
Pow_led2 Alias Porta.6

'FAN_____________________________     
Config Pina.7 = Output                                      'FAN
Fan Alias Porta.7

'RC5_____________________________       RC-5
Config Pinb.0 = Input                                       'RC5

'LIGHT___________________________     
Config Pinb.1 = Output                                      'LIGHT
Light Alias Portb.1

'POWER___________________________     
Config Pinc.4 = Output                                      'POWER
Power_ Alias Portc.4

'MUTE____________________________     
Config Pinc.5 = Output                                      'MUTE
Mute Alias Portc.5

'ALARM_OUT_______________________      
Config Pinc.6 = Output                                      'SYSTEM_SWITCH
System_sw Alias Portc.6

'BUZER___________________________      
Config Pinc.7 = Output                                      'BUZER
Buzer Alias Portc.7

'KEYBOARD________________________     
Config Pind.2 = Output                                      'KEY_1
Key_1 Alias Portd.2
Config Pina.3 = Output                                      'KEY_2
Key_2 Alias Porta.3
Config Pind.4 = Output                                      'KEY_3
Key_3 Alias Portd.4
Config Pind.5 = Input                                       'KEY_4
Key_4 Alias Pind.5
Config Pind.6 = Input                                       'KEY_5
Key_5 Alias Pind.6
Config Pind.7 = Input                                       'KEY_6
Key_6 Alias Pind.7
Set Portd.5
Set Portd.6
Set Portd.7

Config Rc5 = Pinb.0                                         '    RC-5

Config Sda = Portc.0                                        ' SDA  I2C
Config Scl = Portc.2                                        ' SCL  I2C (SCL_1)

Const Ds1307w = &HD0                                        '     DS1307 ()
Const Ds1307r = &HD1                                        '     DS1307 ()

Config Date = Dmy , Separator = .                           '    ,  
Config Clock = User                                         '  

' 
Dim A As Bit , M As Byte
Dim Pulses As Word , Periods As Word
Dim Key As Byte
Dim Address As Byte , Rc5 As Byte
Dim Grey As Byte , Grey_mem(7) As Byte
Dim Plus As Bit , Minus As Bit
Dim Valcod_param As Byte
Dim C As Word
Dim Timer_stop As Bit
Dim Press_key As Bit , Press_rc5 As Bit , Rotate_valcod As Bit
Dim Valcod_cange As Bit
Dim Weekday As Byte

Config Int1 = Falling                                       '   INT1      "1"  "0"
On Int1 Valcoder_change                                     '   Valcoder_change
Enable Int1                                                 '    INT1
Enable Interrupts                                           '  

Cls                                                         '  

Set Light                                                   ' 
Set Pow_led1                                                '  1  
Reset Pow_led2                                              '  2  

Cls                                                         '  
Locate 1 , 10                                               '  
Lcd "Enc=" ; Valcod_param                                   '    ()
Locate 2 , 10                                               '  
Lcd "K? "

Locate 2 , 13                                               '  
Lcd "IR??"

Time$ = "23:58:59"                                          ' ,      DS1307
Date$ = "31-12-07"                                          ' ,      DS1307

Do                                                          ' 
Gosub Keys                                                  '     


Locate 1 , 1                                                '  
Lcd Date$                                                   '   ,        DS1307
Locate 2 , 1                                                '  
Lcd Time$                                                   '   ,        DS1307



If Key = 16 Then                                            '     
               Getrc5(address , Rc5)                        '   RC-5
               Rc5 = Rc5 And &B01111111                     ' 
End If

If Valcod_cange = 1 Then                                    '   Valcod_cange = 1 ( ()
                       Locate 1 , 14                        '   
                       Lcd Valcod_param ; "  "              '    ()
                       Reset Valcod_cange                   '   Valcod_cange
                       Sound Buzer , 10 , 500               ' 
End If


If Key <> 16 Then                                           '    
               Sound Buzer , 10 , 300                       '  
               Locate 2 , 11                                '  
               Lcd Key                                      '    
               Set Press_key                                '   Press_key
End If

If Key = 1 Then                                             '   SW1
             Toggle Light                                   '   
             Toggle Pow_led1                                '   
             Toggle Pow_led2                                '   
             Waitms 200                                     ' 200 
End If

If Press_key = 1 And Key = 16 Then                          '   Press_key=1      
                                  Locate 2 , 11             '   
                                  Lcd "?"                   '     "?"
                                  Reset Press_key           '   Press_key
End If

If Rc5 <> 127 Then                                          '   - 
                  Sound Buzer , 10 , 100                    '  
                  Locate 2 , 15                             '  
                  Lcd Rc5 ; " "                             '      
                  Set Press_rc5                             '   Press_rc5
End If

If Press_rc5 = 1 And Rc5 = 127 Then                         '   Press_rc5=1        
                                   Locate 2 , 15            '   
                                   Lcd "??    "             '      "??"
                                   Reset Press_rc5          '   Press_rc5
End If

Loop                                                        ' 


Valcoder_change:                                            '   INT1
'*******************************************************************************
If Valcod_b = 1 Then                                        '   B  "1"
                  If Valcod_param <> 255 Then Incr Valcod_param       '    Valcod_param    255    1
                Else                                        '   B  "0"
                  If Valcod_param <> 0 Then Decr Valcod_param       '    Valcod_param    0    1
End If
Set Valcod_cange                                            '   Valcod_cange
Return                                                      '  


Keys:                                                       '   
'*******************************************************************************
Key = 16

Reset Key_1                                                 '  
Set Key_2                                                   '  
Set Key_3                                                   '  
nop                                                         '  1 
nop                                                         '  1 
If Key_4 = 0 Then Key = 1                                   '  ,  SW1
If Key_5 = 0 Then Key = 4                                   '  ,  SW4
If Key_6 = 0 Then Key = 7                                   '  ,  SW7

Set Key_1                                                   '  
Reset Key_2                                                 '  
Set Key_3                                                   '  
nop                                                         '  1 
nop                                                         '  1 
If Key_4 = 0 Then Key = 2                                   '  ,  SW2
If Key_5 = 0 Then Key = 5                                   '  ,  SW5
If Key_6 = 0 Then Key = 8                                   '  ,  SW8

Set Key_1                                                   '  
Set Key_2                                                   '  
Reset Key_3                                                 '  
nop                                                         '  1 
nop                                                         '  1 
If Key_4 = 0 Then Key = 3                                   '  ,  SW3
If Key_5 = 0 Then Key = 6                                   '  ,  SW6
If Key_6 = 0 Then Key = 9                                   '   ,  SW9

Return                                                      '  


Getdatetime:                                                '    DS1307
'*******************************************************************************
  I2cstart                                                  ' I2C START
  I2cwbyte Ds1307w                                          '    DS1307
  I2cwbyte 0                                                '    DS1307

  I2cstart                                                  '  I2C START
  I2cwbyte Ds1307r                                          '     DS1307
  I2crbyte _sec , Ack
  I2crbyte _min , Ack                                       '   
  I2crbyte _hour , Ack                                      '   
  I2crbyte Weekday , Ack                                    '   
  I2crbyte _day , Ack                                       '   
  I2crbyte _month , Ack                                     '   
  I2crbyte _year , Nack                                     '   
  I2cstop                                                   'I2C STOP
  _sec = Makedec(_sec) : _min = Makedec(_min) : _hour = Makedec(_hour)       '     
  _day = Makedec(_day) : _month = Makedec(_month) : _year = Makedec(_year)       '     
Return                                                      '  

Setdate:                                                    '    DS1307
'*******************************************************************************
  _day = Makebcd(_day) : _month = Makebcd(_month) : _year = Makebcd(_year)       '     
  I2cstart                                                  ' I2C START
  I2cwbyte Ds1307w                                          '    DS1307
  I2cwbyte 4                                                '    DS1307
  I2cwbyte _day                                             '  
  I2cwbyte _month                                           '  
  I2cwbyte _year                                            '  
  I2cstop                                                   'I2C STOP
Return                                                      '  

Settime:                                                    '    DS1307
'*******************************************************************************
  _sec = Makebcd(_sec) : _min = Makebcd(_min) : _hour = Makebcd(_hour)       '     
  I2cstart                                                  ' I2C START
  I2cwbyte Ds1307w                                          '    DS1307
  I2cwbyte 0                                                '    DS1307
  I2cwbyte _sec                                             '  
  I2cwbyte _min                                             '  
  I2cwbyte _hour                                            '  
  I2cstop                                                   'I2C STOP
Return                                                      '  


End                                                         ' 